%define anolis_release 2

%global gittag0 v1.14.0
# WORKAROUND to avoid breaking the build at the atrocious libtool shell scrip
# due to RPM environmental macros being lost for the subshells
%undefine _package_note_file

Name: memkind
Summary: User Extensible Heap Manager
Version: 1.14.0
Release: %{anolis_release}%{?dist}
License: BSD
URL: http://memkind.github.io/memkind
BuildRequires: make patch
BuildRequires: automake libtool numactl-devel systemd gcc gcc-c++ daxctl-devel

# Upstream testing of memkind is done exclusively on x86_64; other archs
# are unsupported but may work.
ExclusiveArch: x86_64 aarch64 loongarch64

Source0: https://github.com/%{name}/%{name}/archive/%{gittag0}/%{name}-%{version}.tar.gz

# unbreak the atrocious autotools Makefile.am construction for
# libmemkind archive creation target
Patch0: Makefile.am.patch

%description
The memkind library is an user extensible heap manager built on top of
jemalloc which enables control of memory characteristics and a
partitioning of the heap between kinds of memory.  The kinds of memory
are defined by operating system memory policies that have been applied
to virtual address ranges. Memory characteristics supported by
memkind without user extension include control of NUMA and page size
features. The jemalloc non-standard interface has been extended to
enable specialized arenas to make requests for virtual memory from the
operating system through the memkind partition interface. Through the
other memkind interfaces the user can control and extend memory
partition features and allocate memory while selecting enabled
features. This software is being made available for early evaluation.
Feedback on design or implementation is greatly appreciated.

%package devel
Summary: Memkind User Extensible Heap Manager development lib and tools
Requires: %{name} = %{version}-%{release}

%description devel
Install header files and development aids to link memkind library 
into applications. The memkind library is an user extensible heap manager 
built on top of jemalloc which enables control of memory characteristics and
heap partitioning on different kinds of memory. This software is being made 
available for early evaluation. The memkind library should be considered 
pre-alpha: bugs may exist and the interfaces may be subject to change prior to 
alpha release. Feedback on design or implementation is greatly appreciated.

%prep
%setup -q -a 0 -n %{name}-%{version}
%patch0 -p1

%build
cd %{_builddir}/%{name}-%{version}
echo %{version} > %{_builddir}/%{name}-%{version}/VERSION
test -f configure || ./autogen.sh
%configure --enable-secure --enable-tls --prefix=%{_prefix} --libdir=%{_libdir} \
	   --includedir=%{_includedir} --sbindir=%{_sbindir} --bindir=%{_bindir} \
	   --mandir=%{_mandir} --docdir=%{_docdir}/%{name} \
	   CFLAGS="$RPM_OPT_FLAGS -std=gnu99" LDFLAGS="%{build_ldflags}"
%{__make} V=1

%install
cd %{_builddir}/%{name}-%{version}
make DESTDIR=%{buildroot} INSTALL='install -p' install
rm -f %{buildroot}/%{_libdir}/lib%{name}.{l,}a
rm -f %{buildroot}/%{_libdir}/libautohbw.{l,}a
rm -f %{buildroot}/%{_libdir}/libmemtier.{l,}a
rm -f %{buildroot}/%{_docdir}/%{name}/VERSION

%generate_compatibility_deps

%ldconfig_scriptlets

%files
%dir %{abidir}
%{_bindir}/memtier
%{_libdir}/lib%{name}.so.*
%{_libdir}/libautohbw.so.*
%{_libdir}/libmemtier.so.*
%{_bindir}/%{name}-hbw-nodes
%{_bindir}/%{name}-auto-dax-kmem-nodes
%{_mandir}/man1/%{name}*.1.*
%{_mandir}/man1/memtier.1.*
%{_mandir}/man7/autohbw.7.*
%{_mandir}/man7/memtier.7.*
%{_mandir}/man7/libmemtier.7.*
%dir %{_docdir}/%{name}
%doc %{_docdir}/%{name}/README
%license %{_docdir}/%{name}/COPYING
%{abidir}/libautohbw.dump
%{abidir}/lib%{name}.dump
%{abidir}/libmemtier.dump
%{abidir}/memtier-option.list
%{abidir}/%{name}-auto-dax-kmem-nodes-option.list

%files devel
%{_includedir}/%{name}*.h
%{_includedir}/hbwmalloc.h
%{_includedir}/hbw_allocator.h
%{_includedir}/pmem_allocator.h
%{_includedir}/fixed_allocator.h
%{_libdir}/lib%{name}.so
%{_libdir}/libautohbw.so
%{_libdir}/libmemtier.so
%{_libdir}/pkgconfig/memkind.pc
%{_mandir}/man3/%{name}*.3.*
%{_mandir}/man3/hbwmalloc.3.*
%{_mandir}/man3/hbwallocator.3.*
%{_mandir}/man3/pmemallocator.3.*
%{_mandir}/man3/fixedallocator.3.*
%{_mandir}/man3/libmemtier.3.*

%changelog
* Thu Nov 16 2023 Wenlong Zhang<zhangwenlong@loongson.cn> - 1.14.0-2
- fix build error for loongarch64

* Fri Jul 07 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.14.0-1
- Init upstream from version 1.14.0
